/*******************************************************************************
 * MacMain.h
 * POV-Ray_3.7_MacCommandLine
 * Created by yvo on 23/11/13.
 *
 *
 * ---------------------------------------------------------------------------
 * Persistence of Vision Ray Tracer ('POV-Ray') version 3.7.
 * Copyright 1991-2013 Persistence of Vision Raytracer Pty. Ltd.
 *
 * POV-Ray is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * POV-Ray is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ---------------------------------------------------------------------------
 * POV-Ray is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 * ---------------------------------------------------------------------------
 *******************************************************************************/

#ifndef __POV_Ray_3_7_MacCommandLine__MacMain__
#define __POV_Ray_3_7_MacCommandLine__MacMain__
#include <signal.h>
#include <sys/select.h>
#include <termios.h>
#include <unistd.h>
#include <boost/algorithm/string.hpp>
#import <Foundation/Foundation.h>

#include "vfe.h"
#include "MacDisplay.h"
#include "povray.h"
#include "benchmark.h"
using namespace vfePlatform;
using namespace pov_base;
using namespace pov;

enum ReturnValue
{
	RETURN_OK=0,
	RETURN_ERROR,
	RETURN_USER_ABORT
};
//using namespace vfe;
// for handling asynchronous (external) signals
int gSignalNumber = 0;
boost::mutex gSignalMutex;
bool isOptionSet(const char *optionToFind, char **argv);
void CancelRender(vfeMacSession *session);
void PrintVersion(void);
void PrintOptions(void);
extern vfeMacSession *gVfeSession;
void PrintStatusChanged (vfeMacSession *session, State force = kUnknown);
void ErrorExit(vfeMacSession *session);
void PrintStatus (vfeMacSession *session);
void CleanupBenchmark(vfeMacSession *session, string& ini, string& pov);
ReturnValue PrepareBenchmark(vfeMacSession *session, vfeRenderOptions& opts, string& ini, string& pov, int argc, char **argv);

void ProcessSignal (void);


#endif /* defined(__POV_Ray_3_7_MacCommandLine__MacMain__) */
